// mwa.products.db.DBInfo.java
//
// Copyright 1997, Mark Watson.
//
// This software is Copyright 1998 by Mark Watson.
// This software may be freely used for any purpose
// and may be modified for any purpose as long as
// you agree to the following:
//
// 1. Any bug fixes or enhancements that you make must be emailed
//    back to Mark Watson (markw@markwatson.com) for possible
//    inclusion in the source code base that is available at
//    the web site www.markwatson.com (credit will be given
//    to contributers).
//
// 2. This copyright notice must be kept with the source code
//    and duplicated if you distribute a modified verison of
//    this software in binary form.
//
// 3. You will not re-distribute the source code. Rather, any
//    improvements to this program will be returned to Mark
//    Watson so that there is always one source base at
//    the web site www.markwatson.com (you may freely
//    distribute compiled derived versions of this program
//    without any restrictions as long as this entire
//    copyright notice is reproduced with the application
//    (e.g., in the 'help' or 'about' dialog box).
//
// 4. This software may not be used for any illegal purpose.
//
// 5. You take all responsibility for the use of this software:
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

// Open Source contributers:
//
//   Name                        Email (optional)
//   ----                        ----------------
//



package com.markwatson.nlbean;

import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.sql.*;

public class DBInfo implements Serializable {
    public DBInfo() {
        num_tables=0;
        //tables = new DBTable[10]; // arbitrary maximum
	name = new String[10];
	columnNames = new String[10][];
	databaseName = new String[10];
	userName = new String[10];
	password = new String[10];
        temp = new String[20];
    }

  public void clearTables() { num_tables=0; }

    public void addTable(String a_name, String data_base,
                  String user_name, String a_password,
                  String col_names[])
    {
        if (num_tables >= 8) {
            System.out.println("Too many tables");
            System.exit(1);
        }
        //tables[num_tables] = new DBTable();
        name[num_tables] = a_name;
        columnNames[num_tables] = col_names;
        databaseName[num_tables] = data_base;
        userName[num_tables] = user_name;
        password[num_tables] = a_password;
        num_tables++;
    }

    public void debug() {
      for (int i=0; i<num_tables; i++) {
        System.out.print("Table " + name[i] + ": " +
                           databaseName[i] + ", " +
                           userName[i] + ": ");
        for (int j=0; j<columnNames[i].length; j++) {
          System.out.print(columnNames[i][j]);
          if (j!=columnNames[i].length-1) System.out.print(", ");
        }
        System.out.println("");
      }
    }

    public boolean isTable(String s) {
        for (int i=0; i<num_tables; i++) {
            if (name[i].equalsIgnoreCase(s)) return true;
        }
        return false;
    }

    public boolean isColumn(String s) {
        for (int i=0; i<num_tables; i++) {
            for (int j=0; j<columnNames[i].length; j++) {
                if (columnNames[i][j].equalsIgnoreCase(s)) return true;
            }
        }
        return false;
    }

    public String[] findColumnName(String cn) { // return table names
        int count=0;
        for (int i=0; i<num_tables; i++) {
            for (int j=0; j<columnNames[i].length; j++) {
                if (cn.equalsIgnoreCase(columnNames[i][j])) {
                    temp[count++] = name[i];
                }
            }
        }
        if (count==0)  return null;
        String ret[] = new String[count];
        for (int i=0; i<count; i++) ret[i] = temp[i];
        return ret;
    }

    public String name[] = null;
    public String columnNames[][] = null;
    public String databaseName[] = null;
    public String userName[] = null;
    public String password[] = null;

    public int num_tables = 0;
    protected String temp[] = null;
}
