// mwa.products.Util.java
//
// Copyright 1997, Mark Watson.
//
// This software is Copyright 1998 by Mark Watson.
// This software may be freely used for any purpose
// and may be modified for any purpose as long as
// you agree to the following:
//
// 1. Any bug fixes or enhancements that you make must be emailed
//    back to Mark Watson (markw@markwatson.com) for possible
//    inclusion in the source code base that is available at
//    the web site www.markwatson.com (credit will be given
//    to contributers).
//
// 2. This copyright notice must be kept with the source code
//    and duplicated if you distribute a modified verison of
//    this software in binary form.
//
// 3. You will not re-distribute the source code. Rather, any
//    improvements to this program will be returned to Mark
//    Watson so that there is always one source base at
//    the web site www.markwatson.com (you may freely
//    distribute compiled derived versions of this program
//    without any restrictions as long as this entire
//    copyright notice is reproduced with the application
//    (e.g., in the 'help' or 'about' dialog box).
//
// 4. This software may not be used for any illegal purpose.
//
// 5. You take all responsibility for the use of this software:
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

// Open Source contributers:
//
//   Name                        Email (optional)
//   ----                        ----------------
//



package com.markwatson.nlbean;

import java.io.*;

public class Util {

  // PUBLIC UTILITIES:

  // for semicolon deliminated strings:
  public static String [] parseStrings(String s) {
    for (int i=0; i<s.length(); i++) {
      if (s.substring(i,i+1).equals("/")) {
        s = s.substring(0, i) + " " + s.substring(i+1);
      }
      if (s.substring(i,i+1).equals(".")) {
        s = s.substring(0, i) + " " + s.substring(i+1);
      }
      if (s.substring(i,i+1).equals("-")) {
        s = s.substring(0, i) + " " + s.substring(i+1);
      }
    }
    int num=0;
    String words[] = new String[20];
    try {
        s=s.trim();
        StreamTokenizer st = new StreamTokenizer(new StringReader(s));
        st.whitespaceChars(';', ';');
        st.wordChars(',', ',');
        st.wordChars('(', ')');
        try {
            int type;
            while ((type = st.nextToken()) != StreamTokenizer.TT_EOF) {
                if (type==StreamTokenizer.TT_WORD) {
                    if (num < 18) words[num++] = st.sval;
                } else if (type==StreamTokenizer.TT_NUMBER) {
                    if (num < 18) words[num++] = (new Integer((int)st.nval)).toString();
                }
            }
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
            e.printStackTrace ();
        }
    } catch (Exception ioe) {
        System.out.println("Error: " + ioe.getMessage());
        ioe.printStackTrace ();
    }
    if (num>0) {
        String ret[] = new String[num];
        for (int i=0; i<num; i++) {
            ret[i]=words[i];
        }
        return ret;
    }
    return null;
  }
  // same as parseStrings, but handles comma delimiters
  // instead of semicolons:
  public static String [] parseStringsCommas(String s) {
    int num=0;
    String words[] = new String[20];
    try {
        s=s.trim();
        StreamTokenizer st = new StreamTokenizer(new StringReader(s));
        st.whitespaceChars(',', ',');
        try {
            int type;
            while ((type = st.nextToken()) != StreamTokenizer.TT_EOF) {
                if (type==StreamTokenizer.TT_WORD) {
                    if (num < 18) words[num++] = st.sval;
                } else if (type==StreamTokenizer.TT_NUMBER) {
                    if (num < 18) words[num++] = (new Integer((int)st.nval)).toString();
                }
            }
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
            e.printStackTrace ();
        }
    } catch (Exception ioe) {
        System.out.println("Error: " + ioe.getMessage());
        ioe.printStackTrace ();
    }
    if (num>0) {
        String ret[] = new String[num];
        for (int i=0; i<num; i++) {
            ret[i]=words[i];
        }
        return ret;
    }
    return null;
  }

  public static String removeExtraSpaces(String s) {
    for (int i=0; i<10; i++) {
      int idx = s.indexOf("  ");
      if (idx>-1) {
        s = s.substring(0, idx+1) + s.substring(idx+2);
      } else {
        break;
      }
    }
    if (s.startsWith(" ")) s = s.substring(1);
    return s;
  }
}
