// mwa.products.db.ATN.java
//
// Copyright 1997, Mark Watson.
//
// This software is Copyright 1998 by Mark Watson.
// This software may be freely used for any purpose
// and may be modified for any purpose as long as
// you agree to the following:
//
// 1. Any bug fixes or enhancements that you make must be emailed
//    back to Mark Watson (markw@markwatson.com) for possible
//    inclusion in the source code base that is available at
//    the web site www.markwatson.com (credit will be given
//    to contributers).
//
// 2. This copyright notice must be kept with the source code
//    and duplicated if you distribute a modified verison of
//    this software in binary form.
//
// 3. You will not re-distribute the source code. Rather, any
//    improvements to this program will be returned to Mark
//    Watson so that there is always one source base at
//    the web site www.markwatson.com (you may freely
//    distribute compiled derived versions of this program
//    without any restrictions as long as this entire
//    copyright notice is reproduced with the application
//    (e.g., in the 'help' or 'about' dialog box).
//
// 4. This software may not be used for any illegal purpose.
//
// 5. You take all responsibility for the use of this software:
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
// FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
// DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
// OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
// OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
// SUCH DAMAGE.

// Open Source contributers:
//
//   Name                        Email (optional)
//   ----                        ----------------
//



package com.markwatson.nlbean;

import java.io.*;

public class WordList {
    public WordList() {
        num=0;
        words = new String[20];
        parseOK=true;
        num_tagged_words=0;
        tagged_words = new String[20];
        tags = new int[20];
    }
    public WordList(String s) {
        num=0;
        words = new String[20];
        num_tagged_words=0;
        tagged_words = new String[20];
        tags = new int[20];
        parseOK=true;
        try {
            s=s.trim();
            StreamTokenizer st = new StreamTokenizer(new StringReader(s));
            try {
                st.nextToken();
                while (st.sval!=null) {
                   if (num < 18) words[num++] = st.sval;
                   st.nextToken();
                }
            } catch (Exception e) { }
        } catch (Exception ioe) { System.out.println("Error: " + ioe.getMessage()); }
        num_orig=num;
    }

    public boolean parseOK;
    public int num;
    private int num_orig;
    public String words[];
    public String tagged_words[];
    public int tags[];
    int num_tagged_words;
    public WordList copy() {
        WordList wl2 = new WordList();
        wl2.num=this.num;
        wl2.num_orig=this.num_orig;
        wl2.parseOK=this.parseOK;
        if (this.actor!=null) wl2.actor=new String(this.actor);
        else wl2.actor=null;
        if (this.action!=null) wl2.action=new String(this.action);
        else wl2.action=null;
        if (this.object!=null) wl2.object=new String(this.object);
        else wl2.object=null;
        wl2.verb_tense=this.verb_tense;
        wl2.lastWH_Word=this.lastWH_Word;
        for (int i=0; i<this.num; i++) {
            if (this.words[i]!=null) wl2.words[i]=new String(this.words[i]);
            else wl2.words[i]=null;
        }
        wl2.num_tagged_words=this.num_tagged_words;
        for (int i=0; i<this.num_tagged_words; i++) {
            if (this.tagged_words[i]!=null) wl2.tagged_words[i]=new String(this.tagged_words[i]);
            else wl2.tagged_words[i]=null;
            wl2.tags[i]=this.tags[i];
        }
        return wl2;
    }
    public void removeFirst(int part_of_speech) {
        if (num<1) return;
        tagged_words[num_tagged_words] = words[0];
        tags[num_tagged_words++] = part_of_speech;
        System.out.println(words[0] + " :: " + part_of_speech);
        for (int i=0; i<num-1; i++) {
            words[i]=words[i+1];
        }
        num--;
    }
    public float fitness() {
        if (num_orig==0) return 0.0f;
        float val = 1.0f - ((float)num / (float)num_orig);
        float semantic_bonus=0.0f;
        if (actor!=null)  semantic_bonus += 0.03f;
        if (action!=null) semantic_bonus += 0.05f;
        if (object!=null) semantic_bonus += 0.03f;
        return val + semantic_bonus;
    }
    // Semantics related data:
    public String actor=null;
    public String action=null;
    public String object=null;
    public int verb_tense = 0; // 0: present, 1: past, 2: future
    public String last_noun=null;
    public String last_verb=null;
    public String last_adj=null;
    public int lastWH_Word = 0;

}
